OpenVDB: InternalNode< _ChildNodeType, Log2Dim > Class Template Reference

OpenVDB 7.0.0

Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Types | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Friends | List of all members
InternalNode< _ChildNodeType, Log2Dim > Class Template Reference

`#include <InternalNode.h>`

## Classes
struct | ChildAll
struct | ChildIter
struct | ChildOff
struct | ChildOn
struct | DeepCopy
struct | DenseIter
struct | SameConfiguration
| SameConfiguration<OtherNodeType>::value is `true` if and only if OtherNodeType is the type of an InternalNode with the same dimensions as this node and whose ChildNodeType has the same configuration as this node's ChildNodeType. More...
struct | TopologyCopy1
struct | TopologyCopy2
struct | TopologyDifference
struct | TopologyIntersection
struct | TopologyUnion
struct | ValueAll
struct | ValueConverter
| ValueConverter<T>::Type is the type of an InternalNode having the same child hierarchy and dimensions as this node but a different value type, T. More...
struct | ValueIter
struct | ValueOff
struct | ValueOn
struct | VoxelizeActiveTiles

## Public Types
using | ChildNodeType = _ChildNodeType
using | LeafNodeType = typename ChildNodeType::LeafNodeType
using | ValueType = typename ChildNodeType::ValueType
using | BuildType = typename ChildNodeType::BuildType
using | UnionType = NodeUnion< ValueType, ChildNodeType >
using | NodeMaskType = util::NodeMask< Log2Dim >
using | ChildOnIter = ChildIter< InternalNode, ChildNodeType, MaskOnIterator, ChildOn >
using | ChildOnCIter = ChildIter< const InternalNode, const ChildNodeType, MaskOnIterator, ChildOn >
using | ChildOffIter = ValueIter< InternalNode, const ValueType, MaskOffIterator, ChildOff >
using | ChildOffCIter = ValueIter< const InternalNode, const ValueType, MaskOffIterator, ChildOff >
using | ChildAllIter = DenseIter< InternalNode, ChildNodeType, ValueType, ChildAll >
using | ChildAllCIter = DenseIter< const InternalNode, const ChildNodeType, ValueType, ChildAll >
using | ValueOnIter = ValueIter< InternalNode, const ValueType, MaskOnIterator, ValueOn >
using | ValueOnCIter = ValueIter< const InternalNode, const ValueType, MaskOnIterator, ValueOn >
using | ValueOffIter = ValueIter< InternalNode, const ValueType, MaskOffIterator, ValueOff >
using | ValueOffCIter = ValueIter< const InternalNode, const ValueType, MaskOffIterator, ValueOff >
using | ValueAllIter = ValueIter< InternalNode, const ValueType, MaskOffIterator, ValueAll >
using | ValueAllCIter = ValueIter< const InternalNode, const ValueType, MaskOffIterator, ValueAll >

## Public Member Functions
| InternalNode ()
| Default constructor. More...
| InternalNode (const ValueType &offValue)
| Constructor of an InternalNode with dense inactive tiles of the specified value. More...
| InternalNode (const Coord &origin, const ValueType &fillValue, bool active=false)
| Constructs an InternalNode with dense tiles. More...
| InternalNode (PartialCreate, const Coord &, const ValueType &fillValue, bool active=false)
| InternalNode (const InternalNode &)
| Deep copy constructor. More...
template<typename OtherChildNodeType >
| InternalNode (const InternalNode< OtherChildNodeType, Log2Dim > &other)
| Value conversion copy constructor. More...
template<typename OtherChildNodeType >
| InternalNode (const InternalNode< OtherChildNodeType, Log2Dim > &other, const ValueType &background, TopologyCopy)
| Topology copy constructor. More...
template<typename OtherChildNodeType >
| InternalNode (const InternalNode< OtherChildNodeType, Log2Dim > &other, const ValueType &offValue, const ValueType &onValue, TopologyCopy)
| Topology copy constructor. More...
| ~InternalNode ()
ChildOnCIter | cbeginChildOn () const
ChildOffCIter | cbeginChildOff () const
ChildAllCIter | cbeginChildAll () const
ChildOnCIter | beginChildOn () const
ChildOffCIter | beginChildOff () const
ChildAllCIter | beginChildAll () const
ChildOnIter | beginChildOn ()
ChildOffIter | beginChildOff ()
ChildAllIter | beginChildAll ()
ValueOnCIter | cbeginValueOn () const
ValueOffCIter | cbeginValueOff () const
ValueAllCIter | cbeginValueAll () const
ValueOnCIter | beginValueOn () const
ValueOffCIter | beginValueOff () const
ValueAllCIter | beginValueAll () const
ValueOnIter | beginValueOn ()
ValueOffIter | beginValueOff ()
ValueAllIter | beginValueAll ()
Coord | offsetToGlobalCoord (Index n) const
| Return the global coordinates for a linear table offset. More...
const Coord & | origin () const
| Return the grid index coordinates of this node's local origin. More...
void | setOrigin (const Coord &origin)
| Set the grid index coordinates of this node's local origin. More...
Index32 | leafCount () const
void | nodeCount (std::vector< Index32 > &vec) const
Index32 | nonLeafCount () const
Index64 | onVoxelCount () const
Index64 | offVoxelCount () const
Index64 | onLeafVoxelCount () const
Index64 | offLeafVoxelCount () const
Index64 | onTileCount () const
Index64 | memUsage () const
| Return the total amount of memory in bytes occupied by this node and its children. More...
void | evalActiveBoundingBox (CoordBBox &bbox, bool visitVoxels=true) const
| Expand the specified bounding box so that it includes the active tiles of this internal node as well as all the active values in its child nodes. If visitVoxels is false LeafNodes will be approximated as dense, i.e. with all voxels active. Else the individual active voxels are visited to produce a tight bbox. More...
CoordBBox | getNodeBoundingBox () const
| Return the bounding box of this node, i.e., the full index space spanned by the node regardless of its content. More...
bool | isEmpty () const
bool | isConstant (ValueType &firstValue, bool &state, const ValueType &tolerance=zeroVal< ValueType >()) const
bool | isConstant (ValueType &minValue, ValueType &maxValue, bool &state, const ValueType &tolerance=zeroVal< ValueType >()) const
bool | isInactive () const
| Return `true` if this node has no children and only contains inactive values. More...
bool | isValueOn (const Coord &xyz) const
| Return `true` if the voxel at the given coordinates is active. More...
bool | isValueOn (Index offset) const
| Return `true` if the voxel at the given offset is active. More...
bool | hasActiveTiles () const
| Return `true` if this node or any of its child nodes have any active tiles. More...
const ValueType & | getValue (const Coord &xyz) const
bool | probeValue (const Coord &xyz, ValueType &value) const
Index | getValueLevel (const Coord &xyz) const
| Return the level of the tree (0 = leaf) at which the value at the given coordinates resides. More...
const ValueType & | getFirstValue () const
| If the first entry in this node's table is a tile, return the tile's value. Otherwise, return the result of calling getFirstValue() on the child. More...
const ValueType & | getLastValue () const
| If the last entry in this node's table is a tile, return the tile's value. Otherwise, return the result of calling getLastValue() on the child. More...
void | setActiveState (const Coord &xyz, bool on)
| Set the active state of the voxel at the given coordinates but don't change its value. More...
void | setValueOnly (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates but don't change its active state. More...
void | setValueOn (const Coord &xyz)
| Mark the voxel at the given coordinates as active but don't change its value. More...
void | setValueOn (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as active. More...
void | setValueOff (const Coord &xyz)
| Mark the voxel at the given coordinates as inactive but don't change its value. More...
void | setValueOff (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as inactive. More...
template<typename ModifyOp >
void | modifyValue (const Coord &xyz, const ModifyOp &op)
| Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active. More...
template<typename ModifyOp >
void | modifyValueAndActiveState (const Coord &xyz, const ModifyOp &op)
| Apply a functor to the voxel at the given coordinates. More...
template<typename AccessorT >
const ValueType & | getValueAndCache (const Coord &xyz, AccessorT &) const
template<typename AccessorT >
bool | isValueOnAndCache (const Coord &xyz, AccessorT &) const
template<typename AccessorT >
void | setValueAndCache (const Coord &xyz, const ValueType &value, AccessorT &)
template<typename AccessorT >
void | setValueOnlyAndCache (const Coord &xyz, const ValueType &value, AccessorT &)
template<typename ModifyOp , typename AccessorT >
void | modifyValueAndCache (const Coord &xyz, const ModifyOp &op, AccessorT &)
| Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel. More...
template<typename ModifyOp , typename AccessorT >
void | modifyValueAndActiveStateAndCache (const Coord &xyz, const ModifyOp &op, AccessorT &)
template<typename AccessorT >
void | setValueOffAndCache (const Coord &xyz, const ValueType &value, AccessorT &)
template<typename AccessorT >
void | setActiveStateAndCache (const Coord &xyz, bool on, AccessorT &)
template<typename AccessorT >
bool | probeValueAndCache (const Coord &xyz, ValueType &value, AccessorT &) const
template<typename AccessorT >
Index | getValueLevelAndCache (const Coord &xyz, AccessorT &) const
| Return the level of the tree (0 = leaf) at which the value at the given coordinates resides. More...
void | setValuesOn ()
| Mark all values (both tiles and voxels) as active. More...
void | writeTopology (std::ostream &, bool toHalf=false) const
void | readTopology (std::istream &, bool fromHalf=false)
void | writeBuffers (std::ostream &, bool toHalf=false) const
void | readBuffers (std::istream &, bool fromHalf=false)
void | readBuffers (std::istream &, const CoordBBox &, bool fromHalf=false)
void | negate ()
| Change the sign of all the values represented in this node and its child nodes. More...
void | fill (const CoordBBox &bbox, const ValueType &value, bool active=true)
| Set all voxels within a given axis-aligned box to a constant value. More...
void | denseFill (const CoordBBox &bbox, const ValueType &value, bool active=true)
| Set all voxels within a given axis-aligned box to a constant value and ensure that those voxels are all represented at the leaf level. More...
void | voxelizeActiveTiles (bool threaded=true)
| Densify active tiles, i.e., replace them with leaf-level active voxels. More...
template<typename DenseT >
void | copyToDense (const CoordBBox &bbox, DenseT &dense) const
| Copy into a dense grid the values of the voxels that lie within a given bounding box. More...
template<MergePolicy Policy>
void | merge (InternalNode &other, const ValueType &background, const ValueType &otherBackground)
| Efficiently merge another tree into this tree using one of several schemes. More...
template<MergePolicy Policy>
void | merge (const ValueType &tileValue, bool tileActive)
| Merge, using one of several schemes, this node (and its descendants) with a tile of the same dimensions and the given value and active state. More...
template<typename OtherChildNodeType >
void | topologyUnion (const InternalNode< OtherChildNodeType, Log2Dim > &other)
| Union this branch's set of active values with the other branch's active values. The value type of the other branch can be different. More...
template<typename OtherChildNodeType >
void | topologyIntersection (const InternalNode< OtherChildNodeType, Log2Dim > &other, const ValueType &background)
| Intersects this tree's set of active values with the active values of the other tree, whose `ValueType` may be different. More...
template<typename OtherChildNodeType >
void | topologyDifference (const InternalNode< OtherChildNodeType, Log2Dim > &other, const ValueType &background)
| Difference this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if the original voxel is active in this node and inactive in the other node. More...
template<typename CombineOp >
void | combine (InternalNode &other, CombineOp &)
template<typename CombineOp >
void | combine (const ValueType &value, bool valueIsActive, CombineOp &)
template<typename CombineOp , typename OtherNodeType >
void | combine2 (const InternalNode &other0, const OtherNodeType &other1, CombineOp &)
template<typename CombineOp , typename OtherNodeType >
void | combine2 (const ValueType &value, const OtherNodeType &other, bool valIsActive, CombineOp &)
template<typename CombineOp , typename OtherValueType >
void | combine2 (const InternalNode &other, const OtherValueType &, bool valIsActive, CombineOp &)
template<typename BBoxOp >
void | visitActiveBBox (BBoxOp &) const
| Calls the templated functor BBoxOp with bounding box information for all active tiles and leaf nodes in this node. An additional level argument is provided for each callback. More...
template<typename VisitorOp >
void | visit (VisitorOp &)
template<typename VisitorOp >
void | visit (VisitorOp &) const
template<typename OtherNodeType , typename VisitorOp >
void | visit2Node (OtherNodeType &other, VisitorOp &)
template<typename OtherNodeType , typename VisitorOp >
void | visit2Node (OtherNodeType &other, VisitorOp &) const
template<typename IterT , typename VisitorOp >
void | visit2 (IterT &otherIter, VisitorOp &, bool otherIsLHS=false)
template<typename IterT , typename VisitorOp >
void | visit2 (IterT &otherIter, VisitorOp &, bool otherIsLHS=false) const
void | clip (const CoordBBox &, const ValueType &background)
| Set all voxels that lie outside the given axis-aligned box to the background. More...
void | prune (const ValueType &tolerance=zeroVal< ValueType >())
| Reduce the memory footprint of this tree by replacing with tiles any nodes whose values are all the same (optionally to within a tolerance) and have the same active state. More...
void | addLeaf (LeafNodeType *leaf)
| Add the specified leaf to this node, possibly creating a child branch in the process. If the leaf node already exists, replace it. More...
template<typename AccessorT >
void | addLeafAndCache (LeafNodeType *leaf, AccessorT &)
| Same as addLeaf() except, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the coordinate. More...
template<typename NodeT >
NodeT * | stealNode (const Coord &xyz, const ValueType &value, bool state)
| Return a pointer to the node of type `NodeT` that contains voxel (x, y, z) and replace it with a tile of the specified value and state. If no such node exists, leave the tree unchanged and return `nullptr`. More...
bool | addChild (ChildNodeType *child)
| Add the given child node at this level deducing the offset from it's origin. If a child node with this offset already exists, delete the old node and add the new node in its place (i.e. ownership of the new child node is transferred to this InternalNode) More...
void | addTile (Index level, const Coord &xyz, const ValueType &value, bool state)
| Add a tile at the specified tree level that contains voxel (x, y, z), possibly creating a parent branch or deleting a child branch in the process. More...
void | addTile (Index offset, const ValueType &value, bool state)
| Delete any existing child branch at the specified offset and add a tile. More...
template<typename AccessorT >
void | addTileAndCache (Index level, const Coord &xyz, const ValueType &, bool state, AccessorT &)
| Same as addTile() except, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing (x, y, z). More...
template<typename NodeType >
NodeType * | probeNode (const Coord &xyz)
| Return a pointer to the node that contains voxel (x, y, z). If no such node exists, return nullptr. More...
template<typename NodeType >
const NodeType * | probeConstNode (const Coord &xyz) const
template<typename NodeType , typename AccessorT >
NodeType * | probeNodeAndCache (const Coord &xyz, AccessorT &)
| Same as probeNode() except, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing (x, y, z). More...
template<typename NodeType , typename AccessorT >
const NodeType * | probeConstNodeAndCache (const Coord &xyz, AccessorT &) const
LeafNodeType * | probeLeaf (const Coord &xyz)
| Return a pointer to the leaf node that contains voxel (x, y, z). If no such node exists, return `nullptr`. More...
const LeafNodeType * | probeConstLeaf (const Coord &xyz) const
const LeafNodeType * | probeLeaf (const Coord &xyz) const
template<typename AccessorT >
LeafNodeType * | probeLeafAndCache (const Coord &xyz, AccessorT &acc)
| Same as probeLeaf() except, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing (x, y, z). More...
template<typename AccessorT >
const LeafNodeType * | probeConstLeafAndCache (const Coord &xyz, AccessorT &acc) const
template<typename AccessorT >
const LeafNodeType * | probeLeafAndCache (const Coord &xyz, AccessorT &acc) const
LeafNodeType * | touchLeaf (const Coord &xyz)
| Return the leaf node that contains voxel (x, y, z). If no such node exists, create one, but preserve the values and active states of all voxels. More...
template<typename AccessorT >
LeafNodeType * | touchLeafAndCache (const Coord &xyz, AccessorT &)
| Same as touchLeaf() except, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the coordinate. More...
template<typename ArrayT >
void | getNodes (ArrayT &array)
| Adds all nodes of a certain type to a container with the following API: More...
template<typename ArrayT >
void | getNodes (ArrayT &array) const
template<typename ArrayT >
void | stealNodes (ArrayT &array, const ValueType &value, bool state)
| Steals all nodes of a certain type from the tree and adds them to a container with the following API: More...
void | resetBackground (const ValueType &oldBackground, const ValueType &newBackground)
| Change inactive tiles or voxels with value oldBackground to newBackground or -oldBackground to -newBackground. Active values are unchanged. More...
template<typename OtherChildNodeType , Index OtherLog2Dim>
bool | hasSameTopology (const InternalNode< OtherChildNodeType, OtherLog2Dim > *other) const
| Return `true` if the given tree branch has the same node and active value topology as this tree branch (but possibly a different `ValueType`). More...
bool | isValueMaskOn (Index n) const
bool | isValueMaskOn () const
bool | isValueMaskOff (Index n) const
bool | isValueMaskOff () const
bool | isChildMaskOn (Index n) const
bool | isChildMaskOff (Index n) const
bool | isChildMaskOff () const
const NodeMaskType & | getValueMask () const
const NodeMaskType & | getChildMask () const
NodeMaskType | getValueOffMask () const
const UnionType * | getTable () const
template<typename NodeT >
NodeT * | probeNode (const Coord &xyz)
template<typename NodeT , typename AccessorT >
NodeT * | probeNodeAndCache (const Coord &xyz, AccessorT &acc)
template<typename NodeT >
const NodeT * | probeConstNode (const Coord &xyz) const
template<typename NodeT , typename AccessorT >
const NodeT * | probeConstNodeAndCache (const Coord &xyz, AccessorT &acc) const
template<typename AccessorT >
ChildT::LeafNodeType * | probeLeafAndCache (const Coord &xyz, AccessorT &acc)
template<typename AccessorT >
const ChildT::LeafNodeType * | probeLeafAndCache (const Coord &xyz, AccessorT &acc) const
template<typename AccessorT >
const ChildT::LeafNodeType * | probeConstLeafAndCache (const Coord &xyz, AccessorT &acc) const
template<typename AccessorT >
ChildT::LeafNodeType * | touchLeafAndCache (const Coord &xyz, AccessorT &acc)
template<typename AccessorT >
const ChildT::ValueType & | getValueAndCache (const Coord &xyz, AccessorT &acc) const
template<typename OtherChildT >
void | topologyUnion (const InternalNode< OtherChildT, Log2Dim > &other)
template<typename OtherChildT >
void | topologyIntersection (const InternalNode< OtherChildT, Log2Dim > &other, const ValueType &background)
template<typename OtherChildT >
void | topologyDifference (const InternalNode< OtherChildT, Log2Dim > &other, const ValueType &background)
template<typename OtherChildAllIterType , typename VisitorOp >
void | visit2 (OtherChildAllIterType &otherIter, VisitorOp &op, bool otherIsLHS)
template<typename OtherChildAllIterType , typename VisitorOp >
void | visit2 (OtherChildAllIterType &otherIter, VisitorOp &op, bool otherIsLHS) const

## Static Public Member Functions
static Index | dim ()
static Index | getLevel ()
static void | getNodeLog2Dims (std::vector< Index > &dims)
| Populated an stil::vector with the dimension of all the nodes in the branch starting with this node. More...
static Index | getChildDim ()
static Index | coordToOffset (const Coord &xyz)
| Return the linear table offset of the given global or local coordinates. More...
static void | offsetToLocalCoord (Index n, Coord &xyz)
| Return the local coordinates for a linear table offset, where offset 0 has coordinates (0, 0, 0). More...

## Static Public Attributes
static const Index | LOG2DIM = Log2Dim
static const Index | TOTAL = Log2Dim + ChildNodeType::TOTAL
static const Index | DIM = 1 << TOTAL
static const Index | NUM_VALUES = 1 << (3 * Log2Dim)
static const Index | LEVEL = 1 + ChildNodeType::LEVEL
static const Index64 | NUM_VOXELS = uint64_t(1) << (3 * TOTAL)

## Protected Types
using | MaskOnIterator = typename NodeMaskType::OnIterator
using | MaskOffIterator = typename NodeMaskType::OffIterator
using | MaskDenseIterator = typename NodeMaskType::DenseIterator

## Protected Member Functions
void | setValueMask (Index n, bool on)
void | makeChildNodeEmpty (Index n, const ValueType &value)
void | setChildNode (Index i, ChildNodeType *child)
void | resetChildNode (Index i, ChildNodeType *child)
ChildNodeType * | unsetChildNode (Index i, const ValueType &value)
ChildNodeType * | getChildNode (Index n)
| Returns a pointer to the child node at the linear offset n. More...
const ChildNodeType * | getChildNode (Index n) const
| Returns a pointer to the child node at the linear offset n. More...

## Static Protected Member Functions
template<typename NodeT , typename VisitorOp , typename ChildAllIterT >
static void | doVisit (NodeT &, VisitorOp &)
template<typename NodeT , typename OtherNodeT , typename VisitorOp , typename ChildAllIterT , typename OtherChildAllIterT >
static void | doVisit2Node (NodeT &, OtherNodeT &, VisitorOp &)
template<typename NodeT , typename VisitorOp , typename ChildAllIterT , typename OtherChildAllIterT >
static void | doVisit2 (NodeT &, OtherChildAllIterT &, VisitorOp &, bool otherIsLHS)

## Protected Attributes
UnionType | mNodes [NUM_VALUES]
NodeMaskType | mChildMask
NodeMaskType | mValueMask
Coord | mOrigin
| Global grid index coordinates (x,y,z) of the local origin of this node. More...

## Friends
class | IteratorBase< MaskOnIterator, InternalNode >
class | IteratorBase< MaskOffIterator, InternalNode >
class | IteratorBase< MaskDenseIterator, InternalNode >
template<typename , Index >
class | InternalNode
| During topology-only construction, access is needed to protected/private members of other template instances. More...

## Member Typedef Documentation

## ◆ BuildType

using BuildType = typename ChildNodeType::BuildType

## ◆ ChildAllCIter

using ChildAllCIter = DenseIter<const InternalNode,const ChildNodeType, ValueType, ChildAll>

## ◆ ChildAllIter

using ChildAllIter = DenseIter<InternalNode, ChildNodeType, ValueType, ChildAll>

## ◆ ChildNodeType

using ChildNodeType = _ChildNodeType

## ◆ ChildOffCIter

using ChildOffCIter = ValueIter<const InternalNode,const ValueType,MaskOffIterator,ChildOff>

## ◆ ChildOffIter

using ChildOffIter = ValueIter<InternalNode, const ValueType, MaskOffIterator, ChildOff>

## ◆ ChildOnCIter

using ChildOnCIter = ChildIter<const InternalNode,const ChildNodeType,MaskOnIterator,ChildOn>

## ◆ ChildOnIter

using ChildOnIter = ChildIter<InternalNode, ChildNodeType, MaskOnIterator, ChildOn>

## ◆ LeafNodeType

using LeafNodeType = typename ChildNodeType::LeafNodeType

## ◆ MaskDenseIterator

using MaskDenseIterator = typename NodeMaskType::DenseIterator
| protected

## ◆ MaskOffIterator

using MaskOffIterator = typename NodeMaskType::OffIterator
| protected

## ◆ MaskOnIterator

using MaskOnIterator = typename NodeMaskType::OnIterator
| protected

## ◆ NodeMaskType

using NodeMaskType = util::NodeMask<Log2Dim>

## ◆ UnionType

using UnionType = NodeUnion<ValueType, ChildNodeType>

## ◆ ValueAllCIter

using ValueAllCIter = ValueIter<const InternalNode,const ValueType,MaskOffIterator,ValueAll>

## ◆ ValueAllIter

using ValueAllIter = ValueIter<InternalNode, const ValueType, MaskOffIterator, ValueAll>

## ◆ ValueOffCIter

using ValueOffCIter = ValueIter<const InternalNode,const ValueType,MaskOffIterator,ValueOff>

## ◆ ValueOffIter

using ValueOffIter = ValueIter<InternalNode, const ValueType, MaskOffIterator, ValueOff>

## ◆ ValueOnCIter

using ValueOnCIter = ValueIter<const InternalNode, const ValueType, MaskOnIterator, ValueOn>

## ◆ ValueOnIter

using ValueOnIter = ValueIter<InternalNode, const ValueType, MaskOnIterator, ValueOn>

## ◆ ValueType

using ValueType = typename ChildNodeType::ValueType

## Constructor & Destructor Documentation

## ◆ InternalNode() [1/8]

InternalNode | ( |  | ) |
| inline

Default constructor.

Warning
  The resulting InternalNode is uninitialized

## ◆ InternalNode() [2/8]

InternalNode | ( | const ValueType & | offValue | ) |
| inlineexplicit

Constructor of an InternalNode with dense inactive tiles of the specified value.

Parameters

  offValue | Background value used for inactive values

## ◆ InternalNode() [3/8]

InternalNode | ( | const Coord & | origin,
|  | const ValueType & | fillValue,
|  | bool | active = `false`
| ) |  |
| inline

Constructs an InternalNode with dense tiles.

Parameters

  origin | The location in index space of the fist tile value
  fillValue | Value assigned to all the tiles
  active | State assigned to all the tiles

## ◆ InternalNode() [4/8]

InternalNode | ( | PartialCreate | ,
|  | const Coord & | origin,
|  | const ValueType & | fillValue,
|  | bool | active = `false`
| ) |  |
| inline

## ◆ InternalNode() [5/8]

InternalNode | ( | const InternalNode< _ChildNodeType, Log2Dim > & | other | ) |
| inline

Deep copy constructor.

Note
  This method is multi-threaded!

## ◆ InternalNode() [6/8]

InternalNode | ( | const InternalNode< OtherChildNodeType, Log2Dim > & | other | ) |
| inlineexplicit

Value conversion copy constructor.

Note
  This method is multi-threaded!

## ◆ InternalNode() [7/8]

InternalNode | ( | const InternalNode< OtherChildNodeType, Log2Dim > & | other,
|  | const ValueType & | background,
|  | TopologyCopy |
| ) |  |
| inline

Topology copy constructor.

Note
  This method is multi-threaded!

## ◆ InternalNode() [8/8]

InternalNode | ( | const InternalNode< OtherChildNodeType, Log2Dim > & | other,
|  | const ValueType & | offValue,
|  | const ValueType & | onValue,
|  | TopologyCopy |
| ) |  |
| inline

Topology copy constructor.

Note
  This method is multi-threaded!

## ◆ ~InternalNode()

~InternalNode | ( |  | ) |
| inline

## Member Function Documentation

## ◆ addChild()

bool addChild | ( | ChildNodeType * | child | ) |
| inline

Add the given child node at this level deducing the offset from it's origin. If a child node with this offset already exists, delete the old node and add the new node in its place (i.e. ownership of the new child node is transferred to this InternalNode)

Returns
  `true` if inserting the child has been successful, otherwise the caller retains ownership of the node and is responsible for deleting it.

## ◆ addLeaf()

void addLeaf | ( | LeafNodeType * | leaf | ) |
| inline

Add the specified leaf to this node, possibly creating a child branch in the process. If the leaf node already exists, replace it.

## ◆ addLeafAndCache()

void addLeafAndCache | ( | LeafNodeType * | leaf,
|  | AccessorT & | acc
| ) |  |
| inline

Same as addLeaf() except, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the coordinate.

## ◆ addTile() [1/2]

void addTile | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | value,
|  | bool | state
| ) |  |
| inline

Add a tile at the specified tree level that contains voxel (x, y, z), possibly creating a parent branch or deleting a child branch in the process.

## ◆ addTile() [2/2]

void addTile | ( | Index | offset,
|  | const ValueType & | value,
|  | bool | state
| ) |  |
| inline

Delete any existing child branch at the specified offset and add a tile.

## ◆ addTileAndCache()

void addTileAndCache | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | value,
|  | bool | state,
|  | AccessorT & | acc
| ) |  |
| inline

Same as addTile() except, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing (x, y, z).

## ◆ beginChildAll() [1/2]

ChildAllIter beginChildAll | ( |  | ) |
| inline

## ◆ beginChildAll() [2/2]

ChildAllCIter beginChildAll | ( |  | ) | const
| inline

## ◆ beginChildOff() [1/2]

ChildOffIter beginChildOff | ( |  | ) |
| inline

## ◆ beginChildOff() [2/2]

ChildOffCIter beginChildOff | ( |  | ) | const
| inline

## ◆ beginChildOn() [1/2]

ChildOnIter beginChildOn | ( |  | ) |
| inline

## ◆ beginChildOn() [2/2]

ChildOnCIter beginChildOn | ( |  | ) | const
| inline

## ◆ beginValueAll() [1/2]

ValueAllIter beginValueAll | ( |  | ) |
| inline

## ◆ beginValueAll() [2/2]

ValueAllCIter beginValueAll | ( |  | ) | const
| inline

## ◆ beginValueOff() [1/2]

ValueOffIter beginValueOff | ( |  | ) |
| inline

Warning
  This iterator will also visit child nodes so use isChildMaskOn to skip them!

## ◆ beginValueOff() [2/2]

ValueOffCIter beginValueOff | ( |  | ) | const
| inline

Warning
  This iterator will also visit child nodes so use isChildMaskOn to skip them!

## ◆ beginValueOn() [1/2]

ValueOnIter beginValueOn | ( |  | ) |
| inline

## ◆ beginValueOn() [2/2]

ValueOnCIter beginValueOn | ( |  | ) | const
| inline

## ◆ cbeginChildAll()

ChildAllCIter cbeginChildAll | ( |  | ) | const
| inline

## ◆ cbeginChildOff()

ChildOffCIter cbeginChildOff | ( |  | ) | const
| inline

## ◆ cbeginChildOn()

ChildOnCIter cbeginChildOn | ( |  | ) | const
| inline

## ◆ cbeginValueAll()

ValueAllCIter cbeginValueAll | ( |  | ) | const
| inline

## ◆ cbeginValueOff()

ValueOffCIter cbeginValueOff | ( |  | ) | const
| inline

Warning
  This iterator will also visit child nodes so use isChildMaskOn to skip them!

## ◆ cbeginValueOn()

ValueOnCIter cbeginValueOn | ( |  | ) | const
| inline

## ◆ clip()

void clip | ( | const CoordBBox & | clipBBox,
|  | const ValueType & | background
| ) |  |
| inline

Set all voxels that lie outside the given axis-aligned box to the background.

## ◆ combine() [1/2]

void combine | ( | const ValueType & | value,
|  | bool | valueIsActive,
|  | CombineOp & | op
| ) |  |
| inline

## ◆ combine() [2/2]

void combine | ( | InternalNode< _ChildNodeType, Log2Dim > & | other,
|  | CombineOp & | op
| ) |  |
| inline

## ◆ combine2() [1/3]

void combine2 | ( | const InternalNode< _ChildNodeType, Log2Dim > & | other,
|  | const OtherValueType & | value,
|  | bool | valIsActive,
|  | CombineOp & | op
| ) |  |
| inline

## ◆ combine2() [2/3]

void combine2 | ( | const InternalNode< _ChildNodeType, Log2Dim > & | other0,
|  | const OtherNodeType & | other1,
|  | CombineOp & | op
| ) |  |
| inline

## ◆ combine2() [3/3]

void combine2 | ( | const ValueType & | value,
|  | const OtherNodeType & | other,
|  | bool | valIsActive,
|  | CombineOp & | op
| ) |  |
| inline

## ◆ coordToOffset()

Index coordToOffset | ( | const Coord & | xyz | ) |
| inlinestatic

Return the linear table offset of the given global or local coordinates.

## ◆ copyToDense()

void copyToDense | ( | const CoordBBox & | bbox,
|  | DenseT & | dense
| ) |  | const
| inline

Copy into a dense grid the values of the voxels that lie within a given bounding box.

Parameters

  bbox | inclusive bounding box of the voxels to be copied into the dense grid
  dense | dense grid with a stride in z of one (see tools::Dense in tools/Dense.h for the required API)

Note
  bbox is assumed to be identical to or contained in the coordinate domains of both the dense grid and this node, i.e., no bounds checking is performed.

## ◆ denseFill()

void denseFill | ( | const CoordBBox & | bbox,
|  | const ValueType & | value,
|  | bool | active = `true`
| ) |  |
| inline

Set all voxels within a given axis-aligned box to a constant value and ensure that those voxels are all represented at the leaf level.

Parameters

  bbox | inclusive coordinates of opposite corners of an axis-aligned box.
  value | the value to which to set voxels within the box.
  active | if true, mark voxels within the box as active, otherwise mark them as inactive.

See also
  voxelizeActiveTiles()

## ◆ dim()

static Index dim | ( |  | ) |
| inlinestatic

Returns
  The dimension of this InternalNode

The number of voxels in one coordinate direction covered by this node

## ◆ doVisit()

void doVisit | ( | NodeT & | self,
|  | VisitorOp & | op
| ) |  |
| inlinestaticprotected

## ◆ doVisit2()

void doVisit2 | ( | NodeT & | self,
|  | OtherChildAllIterT & | otherIter,
|  | VisitorOp & | op,
|  | bool | otherIsLHS
| ) |  |
| inlinestaticprotected

## ◆ doVisit2Node()

void doVisit2Node | ( | NodeT & | self,
|  | OtherNodeT & | other,
|  | VisitorOp & | op
| ) |  |
| inlinestaticprotected

## ◆ evalActiveBoundingBox()

void evalActiveBoundingBox | ( | CoordBBox & | bbox,
|  | bool | visitVoxels = `true`
| ) |  | const
| inline

Expand the specified bounding box so that it includes the active tiles of this internal node as well as all the active values in its child nodes. If visitVoxels is false LeafNodes will be approximated as dense, i.e. with all voxels active. Else the individual active voxels are visited to produce a tight bbox.

## ◆ fill()

void fill | ( | const CoordBBox & | bbox,
|  | const ValueType & | value,
|  | bool | active = `true`
| ) |  |
| inline

Set all voxels within a given axis-aligned box to a constant value.

Parameters

  bbox | inclusive coordinates of opposite corners of an axis-aligned box
  value | the value to which to set voxels within the box
  active | if true, mark voxels within the box as active, otherwise mark them as inactive

Note
  This operation generates a sparse, but not always optimally sparse, representation of the filled box. Follow fill operations with a prune() operation for optimal sparseness.

## ◆ getChildDim()

static Index getChildDim | ( |  | ) |
| inlinestatic

Returns
  The dimension of the child nodes of this node.

The number of voxels in one coordinate direction covered by a child node of this node.

## ◆ getChildMask()

const NodeMaskType& getChildMask | ( |  | ) | const
| inline

## ◆ getChildNode() [1/2]

ChildT * getChildNode | ( | Index | n | ) |
| inlineprotected

Returns a pointer to the child node at the linear offset n.

Warning
  This protected method assumes that a child node exists at the specified linear offset!

## ◆ getChildNode() [2/2]

const ChildT * getChildNode | ( | Index | n | ) | const
| inlineprotected

Returns a pointer to the child node at the linear offset n.

Warning
  This protected method assumes that a child node exists at the specified linear offset!

## ◆ getFirstValue()

const ChildT::ValueType & getFirstValue | ( |  | ) | const
| inline

If the first entry in this node's table is a tile, return the tile's value. Otherwise, return the result of calling getFirstValue() on the child.

## ◆ getLastValue()

const ChildT::ValueType & getLastValue | ( |  | ) | const
| inline

If the last entry in this node's table is a tile, return the tile's value. Otherwise, return the result of calling getLastValue() on the child.

## ◆ getLevel()

static Index getLevel | ( |  | ) |
| inlinestatic

Returns
  The level of this node

Level 0 is by definition the level of the leaf nodes

## ◆ getNodeBoundingBox()

CoordBBox getNodeBoundingBox | ( |  | ) | const
| inline

Return the bounding box of this node, i.e., the full index space spanned by the node regardless of its content.

## ◆ getNodeLog2Dims()

void getNodeLog2Dims | ( | std::vector< Index > & | dims | ) |
| static

Populated an stil::vector with the dimension of all the nodes in the branch starting with this node.

## ◆ getNodes() [1/2]

void getNodes | ( | ArrayT & | array | ) |
| inline

Adds all nodes of a certain type to a container with the following API:

struct ArrayT {
using value_type = ...;// defines the type of nodes to be added to the array
void push_back(value_type nodePtr);// method that add nodes to the array
};

An example of a wrapper around a c-style array is:

struct MyArray {
using value_type = LeafType*;
value_type* ptr;
MyArray(value_type* array) : ptr(array) {}
void push_back(value_type leaf) { *ptr++ = leaf; }
};

An example that constructs a list of pointer to all leaf nodes is:

std::vector<const LeafNodeType*> array;//most std contains have the required API
array.reserve(tree.leafCount());//this is a fast preallocation.
tree.getNodes(array);

## ◆ getNodes() [2/2]

void getNodes | ( | ArrayT & | array | ) | const
| inline

## ◆ getTable()

const UnionType* getTable | ( |  | ) | const
| inline

## ◆ getValue()

const ChildT::ValueType & getValue | ( | const Coord & | xyz | ) | const
| inline

## ◆ getValueAndCache() [1/2]

const ValueType& getValueAndCache | ( | const Coord & | xyz,
|  | AccessorT & |
| ) |  | const

Return the value of the voxel at the given coordinates and, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ getValueAndCache() [2/2]

const ChildT::ValueType& getValueAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

## ◆ getValueLevel()

Index getValueLevel | ( | const Coord & | xyz | ) | const
| inline

Return the level of the tree (0 = leaf) at which the value at the given coordinates resides.

## ◆ getValueLevelAndCache()

Index getValueLevelAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

Return the level of the tree (0 = leaf) at which the value at the given coordinates resides.

If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ getValueMask()

const NodeMaskType& getValueMask | ( |  | ) | const
| inline

## ◆ getValueOffMask()

NodeMaskType getValueOffMask | ( |  | ) | const
| inline

## ◆ hasActiveTiles()

bool hasActiveTiles | ( |  | ) | const
| inline

Return `true` if this node or any of its child nodes have any active tiles.

## ◆ hasSameTopology()

bool hasSameTopology | ( | const InternalNode< OtherChildNodeType, OtherLog2Dim > * | other | ) | const
| inline

Return `true` if the given tree branch has the same node and active value topology as this tree branch (but possibly a different `ValueType`).

## ◆ isChildMaskOff() [1/2]

bool isChildMaskOff | ( |  | ) | const
| inline

## ◆ isChildMaskOff() [2/2]

bool isChildMaskOff | ( | Index | n | ) | const
| inline

## ◆ isChildMaskOn()

bool isChildMaskOn | ( | Index | n | ) | const
| inline

## ◆ isConstant() [1/2]

bool isConstant | ( | ValueType & | firstValue,
|  | bool & | state,
|  | const ValueType & | tolerance = `zeroVal<ValueType>()`
| ) |  | const
| inline

Return `true` if all of this node's table entries have the same active state and the same constant value to within the given tolerance, and return that value in firstValue and the active state in state.

Note
  This method also returns `false` if this node contains any child nodes.

## ◆ isConstant() [2/2]

bool isConstant | ( | ValueType & | minValue,
|  | ValueType & | maxValue,
|  | bool & | state,
|  | const ValueType & | tolerance = `zeroVal<ValueType>()`
| ) |  | const
| inline

Return `true` if all of this node's tables entries have the same active state and the range of its values satisfy (maxValue - minValue) <= tolerance.

Parameters

  minValue | Is updated with the minimum of all values IF method returns `true`. Else the value is undefined!
  maxValue | Is updated with the maximum of all values IF method returns `true`. Else the value is undefined!
  state | Is updated with the state of all values IF method returns `true`. Else the value is undefined!
  tolerance | The tolerance used to determine if values are approximatly constant.

Note
  This method also returns `false` if this node contains any child nodes.

## ◆ isEmpty()

bool isEmpty | ( |  | ) | const
| inline

Returns
  True if this node contains no child nodes.

## ◆ isInactive()

bool isInactive | ( |  | ) | const
| inline

Return `true` if this node has no children and only contains inactive values.

## ◆ isValueMaskOff() [1/2]

bool isValueMaskOff | ( |  | ) | const
| inline

## ◆ isValueMaskOff() [2/2]

bool isValueMaskOff | ( | Index | n | ) | const
| inline

## ◆ isValueMaskOn() [1/2]

bool isValueMaskOn | ( |  | ) | const
| inline

## ◆ isValueMaskOn() [2/2]

bool isValueMaskOn | ( | Index | n | ) | const
| inline

## ◆ isValueOn() [1/2]

bool isValueOn | ( | const Coord & | xyz | ) | const
| inline

Return `true` if the voxel at the given coordinates is active.

## ◆ isValueOn() [2/2]

bool isValueOn | ( | Index | offset | ) | const
| inline

Return `true` if the voxel at the given offset is active.

## ◆ isValueOnAndCache()

bool isValueOnAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

Return `true` if the voxel at the given coordinates is active and, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ leafCount()

Index32 leafCount | ( |  | ) | const
| inline

## ◆ makeChildNodeEmpty()

void makeChildNodeEmpty | ( | Index | n,
|  | const ValueType & | value
| ) |  |
| inlineprotected

## ◆ memUsage()

Index64 memUsage | ( |  | ) | const
| inline

Return the total amount of memory in bytes occupied by this node and its children.

## ◆ merge() [1/2]

void merge | ( | const ValueType & | tileValue,
|  | bool | tileActive
| ) |  |
| inline

Merge, using one of several schemes, this node (and its descendants) with a tile of the same dimensions and the given value and active state.

## ◆ merge() [2/2]

void merge | ( | InternalNode< _ChildNodeType, Log2Dim > & | other,
|  | const ValueType & | background,
|  | const ValueType & | otherBackground
| ) |  |
| inline

Efficiently merge another tree into this tree using one of several schemes.

Warning
  This operation cannibalizes the other tree.

## ◆ modifyValue()

void modifyValue | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline

Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ modifyValueAndActiveState()

void modifyValueAndActiveState | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline

Apply a functor to the voxel at the given coordinates.

## ◆ modifyValueAndActiveStateAndCache()

void modifyValueAndActiveStateAndCache | ( | const Coord & | xyz,
|  | const ModifyOp & | op,
|  | AccessorT & | acc
| ) |  |
| inline

Apply a functor to the voxel at the given coordinates. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ modifyValueAndCache()

void modifyValueAndCache | ( | const Coord & | xyz,
|  | const ModifyOp & | op,
|  | AccessorT & | acc
| ) |  |
| inline

Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ negate()

void negate | ( |  | ) |
| inline

Change the sign of all the values represented in this node and its child nodes.

## ◆ nodeCount()

void nodeCount | ( | std::vector< Index32 > & | vec | ) | const
| inline

## ◆ nonLeafCount()

Index32 nonLeafCount | ( |  | ) | const
| inline

## ◆ offLeafVoxelCount()

Index64 offLeafVoxelCount | ( |  | ) | const
| inline

## ◆ offsetToGlobalCoord()

Coord offsetToGlobalCoord | ( | Index | n | ) | const
| inline

Return the global coordinates for a linear table offset.

## ◆ offsetToLocalCoord()

void offsetToLocalCoord | ( | Index | n,
|  | Coord & | xyz
| ) |  |
| inlinestatic

Return the local coordinates for a linear table offset, where offset 0 has coordinates (0, 0, 0).

## ◆ offVoxelCount()

Index64 offVoxelCount | ( |  | ) | const
| inline

## ◆ onLeafVoxelCount()

Index64 onLeafVoxelCount | ( |  | ) | const
| inline

## ◆ onTileCount()

Index64 onTileCount | ( |  | ) | const
| inline

## ◆ onVoxelCount()

Index64 onVoxelCount | ( |  | ) | const
| inline

## ◆ origin()

const Coord& origin | ( |  | ) | const
| inline

Return the grid index coordinates of this node's local origin.

## ◆ probeConstLeaf()

const ChildT::LeafNodeType * probeConstLeaf | ( | const Coord & | xyz | ) | const
| inline

## ◆ probeConstLeafAndCache() [1/2]

const LeafNodeType* probeConstLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const

## ◆ probeConstLeafAndCache() [2/2]

const ChildT::LeafNodeType* probeConstLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

## ◆ probeConstNode() [1/2]

const NodeType* probeConstNode | ( | const Coord & | xyz | ) | const

## ◆ probeConstNode() [2/2]

const NodeT* probeConstNode | ( | const Coord & | xyz | ) | const
| inline

## ◆ probeConstNodeAndCache() [1/2]

const NodeType* probeConstNodeAndCache | ( | const Coord & | xyz,
|  | AccessorT & |
| ) |  | const

## ◆ probeConstNodeAndCache() [2/2]

const NodeT* probeConstNodeAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

## ◆ probeLeaf() [1/2]

ChildT::LeafNodeType * probeLeaf | ( | const Coord & | xyz | ) |
| inline

Return a pointer to the leaf node that contains voxel (x, y, z). If no such node exists, return `nullptr`.

## ◆ probeLeaf() [2/2]

const LeafNodeType* probeLeaf | ( | const Coord & | xyz | ) | const

## ◆ probeLeafAndCache() [1/4]

LeafNodeType* probeLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  |

Same as probeLeaf() except, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing (x, y, z).

## ◆ probeLeafAndCache() [2/4]

ChildT::LeafNodeType* probeLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  |
| inline

## ◆ probeLeafAndCache() [3/4]

const LeafNodeType* probeLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const

## ◆ probeLeafAndCache() [4/4]

const ChildT::LeafNodeType* probeLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  | const
| inline

## ◆ probeNode() [1/2]

NodeType* probeNode | ( | const Coord & | xyz | ) |

Return a pointer to the node that contains voxel (x, y, z). If no such node exists, return nullptr.

## ◆ probeNode() [2/2]

NodeT* probeNode | ( | const Coord & | xyz | ) |
| inline

## ◆ probeNodeAndCache() [1/2]

NodeType* probeNodeAndCache | ( | const Coord & | xyz,
|  | AccessorT & |
| ) |  |

Same as probeNode() except, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing (x, y, z).

## ◆ probeNodeAndCache() [2/2]

NodeT* probeNodeAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  |
| inline

## ◆ probeValue()

bool probeValue | ( | const Coord & | xyz,
|  | ValueType & | value
| ) |  | const
| inline

## ◆ probeValueAndCache()

bool probeValueAndCache | ( | const Coord & | xyz,
|  | ValueType & | value,
|  | AccessorT & | acc
| ) |  | const
| inline

Return, in value, the value of the voxel at the given coordinates and, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Returns
  `true` if the voxel at the given coordinates is active

Note
  Used internally by ValueAccessor.

## ◆ prune()

void prune | ( | const ValueType & | tolerance = `zeroVal<ValueType>()` | ) |
| inline

Reduce the memory footprint of this tree by replacing with tiles any nodes whose values are all the same (optionally to within a tolerance) and have the same active state.

## ◆ readBuffers() [1/2]

void readBuffers | ( | std::istream & | is,
|  | bool | fromHalf = `false`
| ) |  |
| inline

## ◆ readBuffers() [2/2]

void readBuffers | ( | std::istream & | is,
|  | const CoordBBox & | clipBBox,
|  | bool | fromHalf = `false`
| ) |  |
| inline

## ◆ readTopology()

void readTopology | ( | std::istream & | is,
|  | bool | fromHalf = `false`
| ) |  |
| inline

## ◆ resetBackground()

void resetBackground | ( | const ValueType & | oldBackground,
|  | const ValueType & | newBackground
| ) |  |
| inline

Change inactive tiles or voxels with value oldBackground to newBackground or -oldBackground to -newBackground. Active values are unchanged.

## ◆ resetChildNode()

void resetChildNode | ( | Index | i,
|  | ChildNodeType * | child
| ) |  |
| inlineprotected

## ◆ setActiveState()

void setActiveState | ( | const Coord & | xyz,
|  | bool | on
| ) |  |
| inline

Set the active state of the voxel at the given coordinates but don't change its value.

## ◆ setActiveStateAndCache()

void setActiveStateAndCache | ( | const Coord & | xyz,
|  | bool | on,
|  | AccessorT & | acc
| ) |  |
| inline

Set the active state of the voxel at the given coordinates without changing its value. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ setChildNode()

void setChildNode | ( | Index | i,
|  | ChildNodeType * | child
| ) |  |
| inlineprotected

## ◆ setOrigin()

void setOrigin | ( | const Coord & | origin | ) |
| inline

Set the grid index coordinates of this node's local origin.

## ◆ setValueAndCache()

void setValueAndCache | ( | const Coord & | xyz,
|  | const ValueType & | value,
|  | AccessorT & | acc
| ) |  |
| inline

Change the value of the voxel at the given coordinates and mark it as active. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ setValueMask()

void setValueMask | ( | Index | n,
|  | bool | on
| ) |  |
| inlineprotected

Use a mask accessor to ensure consistency between the child and value masks; i.e., the value mask should always be off wherever the child mask is on.

## ◆ setValueOff() [1/2]

void setValueOff | ( | const Coord & | xyz | ) |
| inline

Mark the voxel at the given coordinates as inactive but don't change its value.

## ◆ setValueOff() [2/2]

void setValueOff | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

Set the value of the voxel at the given coordinates and mark the voxel as inactive.

## ◆ setValueOffAndCache()

void setValueOffAndCache | ( | const Coord & | xyz,
|  | const ValueType & | value,
|  | AccessorT & | acc
| ) |  |
| inline

Change the value of the voxel at the given coordinates and mark it as inactive. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ setValueOn() [1/2]

void setValueOn | ( | const Coord & | xyz | ) |
| inline

Mark the voxel at the given coordinates as active but don't change its value.

## ◆ setValueOn() [2/2]

void setValueOn | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

Set the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ setValueOnly()

void setValueOnly | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

Set the value of the voxel at the given coordinates but don't change its active state.

## ◆ setValueOnlyAndCache()

void setValueOnlyAndCache | ( | const Coord & | xyz,
|  | const ValueType & | value,
|  | AccessorT & | acc
| ) |  |
| inline

Set the value of the voxel at the given coordinate but preserves its active state. If necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the voxel.

Note
  Used internally by ValueAccessor.

## ◆ setValuesOn()

void setValuesOn | ( |  | ) |
| inline

Mark all values (both tiles and voxels) as active.

## ◆ stealNode()

NodeT * stealNode | ( | const Coord & | xyz,
|  | const ValueType & | value,
|  | bool | state
| ) |  |
| inline

Return a pointer to the node of type `NodeT` that contains voxel (x, y, z) and replace it with a tile of the specified value and state. If no such node exists, leave the tree unchanged and return `nullptr`.

Note
  The caller takes ownership of the node and is responsible for deleting it.

Warning
  Since this method potentially removes nodes and branches of the tree, it is important to clear the caches of all ValueAccessors associated with this tree.

## ◆ stealNodes()

void stealNodes | ( | ArrayT & | array,
|  | const ValueType & | value,
|  | bool | state
| ) |  |
| inline

Steals all nodes of a certain type from the tree and adds them to a container with the following API:

struct ArrayT {
using value_type = ...;// defines the type of nodes to be added to the array
void push_back(value_type nodePtr);// method that add nodes to the array
};

An example of a wrapper around a c-style array is:

struct MyArray {
using value_type = LeafType*;
value_type* ptr;
MyArray(value_type* array) : ptr(array) {}
void push_back(value_type leaf) { *ptr++ = leaf; }
};

An example that constructs a list of pointer to all leaf nodes is:

std::vector<const LeafNodeType*> array;//most std contains have the required API
array.reserve(tree.leafCount());//this is a fast preallocation.
tree.stealNodes(array);

## ◆ topologyDifference() [1/2]

void topologyDifference | ( | const InternalNode< OtherChildNodeType, Log2Dim > & | other,
|  | const ValueType & | background
| ) |  |

Difference this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if the original voxel is active in this node and inactive in the other node.

The last dummy argument is required to match the signature for InternalNode::topologyDifference.

Note
  This operation modifies only active states, not values. Also note that this operation can result in all voxels being inactive so consider subsequnetly calling prune.

## ◆ topologyDifference() [2/2]

void topologyDifference | ( | const InternalNode< OtherChildT, Log2Dim > & | other,
|  | const ValueType & | background
| ) |  |
| inline

## ◆ topologyIntersection() [1/2]

void topologyIntersection | ( | const InternalNode< OtherChildNodeType, Log2Dim > & | other,
|  | const ValueType & | background
| ) |  |

Intersects this tree's set of active values with the active values of the other tree, whose `ValueType` may be different.

The resulting state of a value is active only if the corresponding value was already active AND if it is active in the other tree. Also, a resulting value maps to a voxel if the corresponding value already mapped to an active voxel in either of the two grids and it maps to an active tile or voxel in the other grid.

Note
  This operation can delete branches in this grid if they overlap with inactive tiles in the other grid. Likewise active voxels can be turned into unactive voxels resulting in leaf nodes with no active values. Thus, it is recommended to subsequently call prune.

## ◆ topologyIntersection() [2/2]

void topologyIntersection | ( | const InternalNode< OtherChildT, Log2Dim > & | other,
|  | const ValueType & | background
| ) |  |
| inline

## ◆ topologyUnion() [1/2]

void topologyUnion | ( | const InternalNode< OtherChildNodeType, Log2Dim > & | other | ) |

Union this branch's set of active values with the other branch's active values. The value type of the other branch can be different.

The resulting state of a value is active if the corresponding value was already active OR if it is active in the other tree. Also, a resulting value maps to a voxel if the corresponding value already mapped to a voxel OR if it is a voxel in the other tree. Thus, a resulting value can only map to a tile if the corresponding value already mapped to a tile AND if it is a tile value in other tree.

Specifically, active tiles and voxels in this branch are not changed, and tiles or voxels that were inactive in this branch but active in the other branch are marked as active in this branch but left with their original values.

## ◆ topologyUnion() [2/2]

void topologyUnion | ( | const InternalNode< OtherChildT, Log2Dim > & | other | ) |
| inline

## ◆ touchLeaf()

ChildT::LeafNodeType * touchLeaf | ( | const Coord & | xyz | ) |
| inline

Return the leaf node that contains voxel (x, y, z). If no such node exists, create one, but preserve the values and active states of all voxels.

Use this method to preallocate a static tree topology over which to safely perform multithreaded processing.

## ◆ touchLeafAndCache() [1/2]

LeafNodeType* touchLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & |
| ) |  |

Same as touchLeaf() except, if necessary, update the accessor with pointers to the nodes along the path from the root node to the node containing the coordinate.

## ◆ touchLeafAndCache() [2/2]

ChildT::LeafNodeType* touchLeafAndCache | ( | const Coord & | xyz,
|  | AccessorT & | acc
| ) |  |
| inline

## ◆ unsetChildNode()

ChildT * unsetChildNode | ( | Index | i,
|  | const ValueType & | value
| ) |  |
| inlineprotected

## ◆ visit() [1/2]

void visit | ( | VisitorOp & | op | ) |
| inline

## ◆ visit() [2/2]

void visit | ( | VisitorOp & | op | ) | const
| inline

## ◆ visit2() [1/4]

void visit2 | ( | IterT & | otherIter,
|  | VisitorOp & | ,
|  | bool | otherIsLHS = `false`
| ) |  |

## ◆ visit2() [2/4]

void visit2 | ( | IterT & | otherIter,
|  | VisitorOp & | ,
|  | bool | otherIsLHS = `false`
| ) |  | const

## ◆ visit2() [3/4]

void visit2 | ( | OtherChildAllIterType & | otherIter,
|  | VisitorOp & | op,
|  | bool | otherIsLHS
| ) |  |
| inline

## ◆ visit2() [4/4]

void visit2 | ( | OtherChildAllIterType & | otherIter,
|  | VisitorOp & | op,
|  | bool | otherIsLHS
| ) |  | const
| inline

## ◆ visit2Node() [1/2]

void visit2Node | ( | OtherNodeType & | other,
|  | VisitorOp & | op
| ) |  |
| inline

## ◆ visit2Node() [2/2]

void visit2Node | ( | OtherNodeType & | other,
|  | VisitorOp & | op
| ) |  | const
| inline

## ◆ visitActiveBBox()

void visitActiveBBox | ( | BBoxOp & | op | ) | const
| inline

Calls the templated functor BBoxOp with bounding box information for all active tiles and leaf nodes in this node. An additional level argument is provided for each callback.

Note
  The bounding boxes are guarenteed to be non-overlapping.

## ◆ voxelizeActiveTiles()

void voxelizeActiveTiles | ( | bool | threaded = `true` | ) |
| inline

Densify active tiles, i.e., replace them with leaf-level active voxels.

Parameters

  threaded | if true, this operation is multi-threaded (over the internal nodes).

See also
  denseFill()

## ◆ writeBuffers()

void writeBuffers | ( | std::ostream & | os,
|  | bool | toHalf = `false`
| ) |  | const
| inline

## ◆ writeTopology()

void writeTopology | ( | std::ostream & | os,
|  | bool | toHalf = `false`
| ) |  | const
| inline

## Friends And Related Function Documentation

## ◆ InternalNode

friend class InternalNode
| friend

During topology-only construction, access is needed to protected/private members of other template instances.

## ◆ IteratorBase< MaskDenseIterator, InternalNode >

friend class IteratorBase< MaskDenseIterator, InternalNode >
| friend

## ◆ IteratorBase< MaskOffIterator, InternalNode >

friend class IteratorBase< MaskOffIterator, InternalNode >
| friend

## ◆ IteratorBase< MaskOnIterator, InternalNode >

friend class IteratorBase< MaskOnIterator, InternalNode >
| friend

Allow iterators to call mask accessor methods (setValueMask(), setChildMask(), etc.).

## Member Data Documentation

## ◆ DIM

const Index DIM = 1 << TOTAL
| static

## ◆ LEVEL

const Index LEVEL = 1 + ChildNodeType::LEVEL
| static

## ◆ LOG2DIM

const Index LOG2DIM = Log2Dim
| static

## ◆ mChildMask

NodeMaskType mChildMask
| protected

## ◆ mNodes

UnionType mNodes[NUM_VALUES]
| protected

## ◆ mOrigin

Coord mOrigin
| protected

Global grid index coordinates (x,y,z) of the local origin of this node.

## ◆ mValueMask

NodeMaskType mValueMask
| protected

## ◆ NUM_VALUES

const Index NUM_VALUES = 1 << (3 * Log2Dim)
| static

## ◆ NUM_VOXELS

const Index64 NUM_VOXELS = uint64_t(1) << (3 * TOTAL)
| static

## ◆ TOTAL

const Index TOTAL = Log2Dim + ChildNodeType::TOTAL
| static

The documentation for this class was generated from the following file:

- InternalNode.h